%define xorg_server_version 1.2.99.903
%define xgl_version 0.%{xorg_server_version}
%define mesa_version 6.5.2

%global md5sum_src0 e3013c42e2a450024983c78f5b0b4474
%global md5sum_src1 e4d894181f1859651658b3704633e10d

%define _x11fontdirprefix	%{_datadir}
%define _x11fontdir		%{_x11fontdirprefix}/X11/fonts

%global momorel 2

Name:           xorg-x11-server-Xgl
Version:        %{xgl_version}
Release: %{momorel}m%{?dist}
Summary:        Xserver that uses OpenGL for its drawing operations.
URL:            http://www.freedesktop.org/Software/Xgl/
License:        MIT/X
Group:          User Interface/X

#%%NoSource 0 http://xorg.freedesktop.org/releases/individual/xserver/xorg-server-%{xorg_server_version}.tar.bz2 %{md5sum_src0}
Source0: xgl-20070322.tar.bz2
%NoSource 1 http://jaist.dl.sourceforge.net/sourceforge/mesa3d/MesaLib-%{mesa_version}.tar.bz2 %{md5sum_src1}
Patch1:  xgl-security-file-dir.diff
Patch2:  xgl-xpstubs-link-hack.diff
Patch3:  xgl-maprules-tolower-fix.diff
Patch4:  178214.diff
Patch5:  xgl-java-wmhack.diff

Patch10: Mesa-x86_64-fixes.patch

ExclusiveArch: %ix86 x86_64 ppc ppc64 ia64

BuildRoot:      %{_tmppath}/%{name}-%{version}-root
PreReq:		gdm
BuildRequires:  freeglut-devel, freetype-devel, GConf2-devel, libpng-devel
BuildRequires:  libdrm-devel, libxkbui-devel
BuildRequires:  glitz-devel >= 0.5.6-1m
BuildRequires:  libX11-devel, mesa-libGL-devel, freeglut-devel
BuildRequires:  libXau-devel, libXfont-devel, libXdmcp-devel
BuildRequires:  xorg-x11-proto-devel >= 7.0-8m
Obsoletes:      xgl

%description
Xgl is an Xserver that uses OpenGL for its drawing operations. Some
operations like antialiased font rendering is noticably faster with
this technology, and future graphics hardware might only have support
for 3D operations and no 2D core any more.

Note that this is highly experimental code, it has been tested only on
few hardware platforms, and depending on driver state it may even crash
your computer.


%prep
%setup -q -c -a 1

pushd xgl*
# pushd xserver*
# %patch1 -p0 -b .sec_file
# %patch2 -p0 -b .xpstubs
# %patch3 -p0 -b .maprule
# %patch4 -p0 -b .178214
%patch5 -p0 -b .java_wmhack
popd

pushd Mesa*
%patch10 -p1

%build
# pushd xorg-server*
pushd xgl*
autoreconf -if
# make distclean
%configure  --enable-xgl --disable-xorg --disable-xprint \
	    --disable-dmx --disable-xvfb --disable-xnest --enable-xglx \
	    --enable-glx --enable-dri --enable-dbe --disable-aiglx \
	    --enable-multibuffer --enable-composite \
	    --with-rgb-path=%{_libdir}/xorg/rgb \
	    --with-module-dir=%{_libdir}/xorg/modules \
	    --with-release-snap=1 \
	    --with-default-font-path=%{_x11fontdir}/TrueType,%{_x11fontdir}/japanese,%{_x11fontdir}/misc,%{_x11fontdir}/75dpi \
	    --sysconfdir=/etc/X11 --localstatedir=/var \
	    --enable-xkb \
	    --with-xkb-path=/etc/X11/xkb --with-xkb-output=/etc/X11/xkb/compiled
#	    --with-mesa-source=%{_builddir}/%{name}-%{version}/Mesa-%{mesa_version} \
%make

%install
rm -rf %{buildroot}
# pushd xorg-server*
pushd xgl*
make DESTDIR=%{buildroot} install
popd

# remove unneeded files
rm -rf %{buildroot}%{_libdir}/xorg/modules/xgl/*.la
rm -rf %{buildroot}%{_libdir}/pkgconfig
rm -rf %{buildroot}%{_libdir}/xserver/SecurityPolicy
rm -rf %{buildroot}%{_datadir}/share
rm -rf %{buildroot}%{_datadir}/man
rm -rf %{buildroot}%{_datadir}/aclocal/xorg-server.m4
rm -rf %{buildroot}/etc/X11/xserver/SecurityPolicy
rm -rf %{buildroot}/etc/X11/xkb/compiled/README.compiled

%post
GDM_CONF_FILE=%{_datadir}/gdm/defaults.conf
if ! grep -q -i '\[server-xgl\]' $GDM_CONF_FILE ; then
	cp -f $GDM_CONF_FILE $GDM_CONF_FILE.rpmsave
	cat >> $GDM_CONF_FILE \
<< EOF
# Experimental build of Xgl
[server-xgl]
name=Xgl server
command=/usr/bin/Xgl -accel glx:pbuffer -accel xv:pbuffer -audit 0
flexible=false
EOF
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%{_bindir}/Xgl
%dir %{_libdir}/xorg/modules/xgl
%{_libdir}/xorg/modules/xgl/lib*.so

%changelog
* Sat Jun 23 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.1.2.99.903-2m)
- add PreReq: gdm

* Wed Apr 11 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.1.2.99.903-1m)
- update xgl-20070322

* Sat Mar 31 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.0.20060728-4m)
- BuildRequires: freetype2-devel -> freetype-devel

* Thu Oct 19 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.20060728-3m)
- change ./autogen.sh to each autotools

* Sun Oct 15 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.20060728-2m)
- rebuild against freeglut

* Sun Jul 30 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060728-1m)
- update 20060728

* Sun Jul 16 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060715-1m)
- update 20060715

* Sat Jul  8 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060706-1m)
- update 20060706

* Fri Jun 16 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060522-2m)
- enable xkb

* Fri Jun 16 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060522-1m)
- rename xgl -> xorg-x11-server-Xgl 
- remove Patch:          Xserver-suse-sysconfig.diff
- add %post : add Xgl setting

* Tue Jun 13 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060522-1m)
- update 20060522

* Wed May 24 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.20060313-3m)
- security fix
--  http://xorg.freedesktop.org/releases/X11R7.0/patches/index.html

* Sun Apr  2 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.20060313-2m)
- security fix
--  http://xorg.freedesktop.org/releases/X11R7.0/patches/index.html

* Fri Mar 31 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.20060313-1m)
- initial commit
